function giveConsentGC(detail) {

	if (detail !== null && typeof detail.gc_consent_google_tagmanager !== 'undefined') {
		CheckConsentGoogle(detail, 'google_tagmanager');
	}
	if (detail !== null && typeof detail.gc_consent_analytics !== 'undefined') {
		CheckConsentGoogle(detail, 'analytics');
		if (detail.gc_consent_analytics === true) {
			$('head script[data-gc-cmp-id="gc-allgemein"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						GoogleConsentAddScript('gc-allgemein', index, f, document.head, detail);
					}, 200, this);
				}
			});
			sendConsentToAnalytics('grant');
		} else {
			sendConsentToAnalytics('revoke');
		}
	}
	if (detail !== null && typeof detail.gc_consent_adwords !== 'undefined') {
		CheckConsentGoogle(detail, 'adwords');
		if (detail.gc_consent_adwords === true) {
			$('head script[data-gc-cmp-id="gc-allgemein"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						GoogleConsentAddScript('gc-allgemein', index, f, document.head, detail);
					}, 200, this);
				}
			});
			sendConsentToAdwords('grant');
		} else {
			sendConsentToAdwords('revoke');
		}
	}

	if (detail !== null && typeof detail.gc_analytics !== 'undefined') {
			if (detail.gc_analytics === true) {
				sendConsentToAnalytics('grant');
			} else {
				sendConsentToAnalytics('revoke');
			}
	}

	if (detail !== null && typeof detail.gc_adwords !== 'undefined') {
			if (detail.gc_adwords === true) {
				sendConsentToAdwords('grant');
			} else {
				sendConsentToAdwords('revoke');
			}
	}

}



function sendConsentToAnalytics(action, count = 0){
    if (typeof gtag !== 'undefined'){
    	if (action == 'grant') {
		    gtag('consent', 'update', {
				  analytics_storage: 'granted',
				});
				gtag('event', 'Consent: analytics_storage');
				console.log('Consent für Analytics (gtag) gewährt');
			} else if (action == 'revoke') {
				gtag('consent', 'update', {
				  analytics_storage: 'denied',
				});
				//gtag('event', 'Als Alternative zu', {'analytics_storage': 'denied'});
				console.log('Consent für Analytics (gtag) entzogen');
			}
    } else if (count < 50) {
      setTimeout(function () {
      	count++;
      	sendConsentToAnalytics(action, count);
				console.log('Warten auf gtag(): Versuch ' + count + '; ' + typeof gtag);
      }, 100)
    } 
}

function sendConsentToAdwords(action, count = 0){
    if (typeof gtag !== 'undefined'){
    	if (action == 'grant') {
				gtag('consent', 'update', {
				  ad_storage: 'granted',
				  ad_user_data: 'granted',
				  ad_personalization: 'granted',
				  personalization_storage: 'granted'
				});

				setTimeout (function(){
					gtag('set', 'ads_data_redaction', false);
					gtag('set', 'url_passthrough', true);
				}, 500);
				gtag('event', 'Consent: ad_storage');
				console.log('Consent für Adwords (gtag) gewährt');
			} else if (action == 'revoke') {
				gtag('consent', 'update', {
				  ad_storage: 'denied',
				  ad_user_data: 'denied',
				  ad_personalization: 'denied',
				  personalization_storage: 'denied'
				});

				setTimeout (function(){
					gtag('set', 'ads_data_redaction', true);
					gtag('set', 'url_passthrough', false);
				}, 500);
				//gtag('event', 'Consent Update', {'ad_storage': 'denied'});
				console.log('Consent für Adwords (gtag) entzogen');
			}
    } else if (count < 50) {
      setTimeout(function () {
      	count++;
      	sendConsentToAdwords(action, count);
				console.log('Warten auf gtag(): Versuch ' + count + '; ' + typeof gtag);
      }, 100)
    }
}

function CheckConsentGoogle(detail, service, dependencies = '') {
	if (eval('detail.gc_consent_' + service) === true) {
		if (dependencies == '') {
			$('head script[data-gc-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						GoogleConsentAddScript(service, index, f, document.head, detail);
					}, 200, this);
				}
			});
			$('body script[data-gc-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						GoogleConsentAddScript(service, index, f, document.body, detail);
					}, 200, this);
				}
			});
			console.log('Consent für ' + service  + ' gewährt');
		} else {
			$('head script[data-gc-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					GoogleConsentAddScript(service, index, f, document.head, detail);
				}, 200, this);
			});
			$('body script[data-gc-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					GoogleConsentAddScript(service, index, f, document.body, detail);
				}, 200, this);
			});
			console.log('Consent für ' + service  +  ' (dep ' + dependencies + ') gewährt');
		}
	} else {
		console.log('Consent für ' + service  + ' entzogen');
	}
}

function GoogleConsentAddScript(service, index, element, parent, detail) {
	var script = document.createElement("script");
	script.setAttribute("type", "text/javascript");
	script.async = true;
	script.defer = true;
	if (typeof $(element).attr('src') !== "undefined") {
		script.setAttribute("src", $(element).attr('src'));
	//	if (typeof $(element).attr('data-onload') !== "undefined") {
		//		//script.addEventListener('load', $(element).attr('data-onload'));
	//		script.onload = eval('window.onload = function() {' + $(element).attr('data-onload') + '};');
	//		console.log('loaded');
	//	}
	}
	//console.log($(element).text());
	//script.innerText =  $(element).text();
	setInnerHTML(script, $(element).text());
	script.setAttribute("data-gc-cmp-set-id", service);
	script.setAttribute("data-gc-consent-given", "true");
	if (element.hasAttribute('data-dependencies')) {
		script.addEventListener("load", function(event) {
			console.log(service + ': dependencies on src');
			CheckConsentGoogle(detail, service, element.getAttribute('data-dependencies'));
		});
		if (!script.hasAttribute('src')) {
			console.log(service + ': dependencies without src');
			CheckConsentGoogle(detail, service, element.getAttribute('data-dependencies'));
		}
	}
	if (null !== element.parentNode) {
		//console.log(element);
		element.parentNode.replaceChild(script, element);
	}
}



var setInnerHTML = function(elm, html) {
  elm.innerHTML = html;
  Array.from(elm.querySelectorAll("script")).forEach( oldScript => {
    const newScript = document.createElement("script");
    Array.from(oldScript.attributes)
      .forEach( attr => newScript.setAttribute(attr.name, attr.value) );
    newScript.appendChild(document.createTextNode(oldScript.innerHTML));
    oldScript.parentNode.replaceChild(newScript, oldScript);
  });
}